﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Silverlight.Testing;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using System.Linq;
using IdeaBlade.Core;
using IdeaBlade.EntityModel;
using IdeaBlade.Linq;
using IdeaBlade.Validation;
using SimpleSteps;

namespace SilverlightTest {
  [TestClass]
  public class Tests : Microsoft.Silverlight.Testing.SilverlightTest {
    NorthwindIBEntities _mgr = new NorthwindIBEntities();

    [TestMethod]
    [Asynchronous]
    [Tag("Fetch")]
    public void RetrieveFrenchCustomers() {
      var query = _mgr.Customers.Where(c => c.Country == "France");
      _mgr.ExecuteQueryAsync<Customer>(query, GotCustomers, null);
    }

    [TestMethod]
    [Asynchronous]
    [Tag("Fetch")]
    public void RetrieveFrenchCustomersFail() {
      var query = _mgr.Customers.Where(c => c.Country == "XXXFrance");
      _mgr.ExecuteQueryAsync<Customer>(query, GotCustomers, null);
    }

    [TestMethod]
    [Asynchronous]
    [Tag("Fetch")]
    public void RetrieveUSCustomers() {
      var query = _mgr.Customers.Where(c => c.Country == "USA");
      _mgr.ExecuteQueryAsync<Customer>(query, GotCustomers, null);
    }

    public void GotCustomers(EntityQueryOperation<Customer> args) {
      Assert.IsTrue(args.Results.Count() > 0, "Expected to retrieve some customers, but found none.");
      base.TestComplete();
    }
  }
}